package praktikum02;

public class ZahlenfilterExtended {
    int length = 200;

    public static void main(String[] args) {
        ZahlenfilterExtended zahlenfilter = new ZahlenfilterExtended();


        if(args.length >0){
            try{
                zahlenfilter.length = Integer.parseInt(args[0]);
            }
            catch (NumberFormatException e){
                System.out.println("Das geht nicht. Default: 200");
            }
        }
        zahlenfilter.checknumber();
    }


    public void checknumber(){
        for (int i = 1; i <= length; i++) {
            if (filter(i)) {
                System.out.println(i + " erfüllt kein Kriterium");
            }
        }
    }


    public void checkDurch5(int zahl) {
        if (zahl % 5 == 0) {
            System.out.println(zahl + " ist durch 5 teilbar!");
        }
    }

    public void checkEndet9(int zahl) {
        if (zahl % 10 == 9) {
            System.out.println(zahl + " endet auf 9!");
        }
    }

    public void checkSummeDurch3(int zahl, int vorgaenger) {
        int summe = zahl + vorgaenger;
        if (summe % 3 == 0) {
            System.out.println(zahl + " und " + vorgaenger + " addiert ergeben "
                    + summe + " und " + summe + " ist durch 3 teilbar!");
        }
    }
    public void printNumbers(){
        for (int i=1; i<length; i++)
            if (filter(i))
                System.out.println(i);
    }

    public static boolean filter(int i){
        return !(checkDivisibleBy5(i)|| checkEndsWith9(i) || checkSumDivisibleBy3(i));

    }
    public static boolean checkDivisibleBy5(int number) {
        return number % 5 == 0;
    }

    public static boolean checkEndsWith9(int number) {
        return number % 10 == 9;
    }

    public static boolean checkSumDivisibleBy3(int number) {
        int pred = number - 1;
        int sum = number + pred;
        return sum % 3 == 0;
    }
}